#include <stdio.h>
#include <stdlib.h>

#define NUMPTS 8

main(){
  int ax[NUMPTS+1],bx[NUMPTS+1],cx[NUMPTS+1],
      ay[NUMPTS+1],by[NUMPTS+1],cy[NUMPTS+1],
      x[NUMPTS+1],y[NUMPTS+1],t[NUMPTS+1][NUMPTS+1];

  int i,j,k,act,converge;

  printf("Type in the patterns like this:\n0 1 1 1 0 0 1 0\n\n");

  printf("Type in the first (A) pattern:  \n");
  for (i=1;i<=NUMPTS;scanf("%d",&ax[i++]));
  printf("---------------\n");
  for (i=1;i<=NUMPTS;printf("%d ",ax[i++]));

  printf("\n\nType in the second (B) pattern:  \n");
  for (i=1;i<=NUMPTS;scanf("%d",&bx[i++]));
  printf("---------------\n");
  for (i=1;i<=NUMPTS;printf("%d ",bx[i++]));

  printf("\n\nType in the third (C) pattern:  \n");
  for (i=1;i<=NUMPTS;scanf("%d",&cx[i++]));
  printf("---------------\n");
  for (i=1;i<=NUMPTS;printf("%d ",cx[i++]));

  printf ("\n\nType in the test (X) pattern:  \n");
  for (i=1;i<=NUMPTS;scanf("%d",&x[i++]));
  printf("---------------\n");
  for (i=1;i<=NUMPTS;printf("%d ",x[i++]));

  printf("\n");

  for(i=1;i<=NUMPTS;i++) {
       ay[i]=2*ax[i]-1;
       by[i]=2*bx[i]-1;
       cy[i]=2*cx[i]-1;
	y[i]=2*x[i] -1;
}


  /* compute the weights */

  for (i=1;i<=NUMPTS;i++)
     for(j=i;j<=NUMPTS;j++){
       if (j==i) t[i][j]=0;
       else {
	  t[i][j]=ay[i]*ay[j]+by[i]*by[j]+cy[i]*cy[j];
	  t[j][i]=t[i][j];
       }
  }

    puts("\nNow revising pattern...\n");


  /* randomly revise nodes */

  randomize();

  converge=0;

  while(!converge) {


    i=random(NUMPTS)+1;

    /* update node i */
    act=0;
    for (j=1;j<=NUMPTS;j++) act+=t[i][j]*y[j];
    y[i]=2*(act>=0)-1;
    for (j=1;j<=NUMPTS;printf("%d ",(y[j++]> 0)));
    printf(" .... i= %d  \n",i);
    /* check for convergence */
    converge=1;
    for(k=1;k<=NUMPTS;k++){
       act=0;
       for (j=1;j<=NUMPTS;j++) act+=t[j][k]*y[j];
       converge*=(y[k]==(2*(act>=0)-1));
    }

  } /* end while loop */


  printf("The final pattern is\n");
  for (i=1;i<=NUMPTS;printf("%d ",(y[i++]>0)));


} /* end main */
