#include <stdio.h>
#include <stdlib.h>
#include <math.h>

float sig(float);

main(){
  float m[5][5],x[5][5],act,gain,bigm=-100;
  int i1,i2,j1,j2,i,j,k;

  randomize();

  puts("Type in the rows of costs like this:");
  puts("12 13.6 16 23.1");

  /* get costs and initialize nodes */

  for (i=1;i<5;i++){
    printf("What are the costs for row %d?\n",i);
    for(j=1;j<5;j++) {
       scanf("%f",&m[i][j]);
       if (m[i][j]>bigm) bigm=m[i][j];   /* find biggest cost */
       x[i][j]=random(1000)/1000.0;      /* initialize node */
    }
  }

  gain=2/bigm;


/* randomly update nodes */

  for (k=1;k<=250;k++){
    i1=random(4)+1;
    j1=random(4)+1;
    printf("old x%d%d = %7.4f  ",i1,j1,x[i1][j1]);

    act=2*bigm-m[i1][j1];
    for (i2=1;i2<5;i2++) if (i2!=i1) act-=2*bigm*x[i2][j1];
    for (j2=1;j2<5;j2++) if (j2!=j1) act-=2*bigm*x[i1][j2];
    x[i1][j1]=sig(gain*act);
    
    printf(
    "Activization = %10.5f  new x%d%d = %7.4f \n",
    act,i1,j1,x[i1][j1]);

  } /* end k loop */

  printf ("\nThe final assignments are: \n\n");
  for (i=1;i<5;i++){

    for(j=1;j<5;j++) printf(" %d ",(x[i][j]>0.5) );
    printf("\n");

  }


} /* end main */

float sig(float x)
{   float y;
    y=1.0/(1.0+exp(-x));
    return(y);
}   /* end function sig */
